import {
  NativeModulesProxy,
  EventEmitter,
  Subscription,
} from "expo-modules-core";

// Import the native module. On web, it will be resolved to ReactNativeOCR.web.ts
// and on native platforms to ReactNativeOCR.ts
import ReactNativeOCRModule from "./ReactNativeOCRModule";
import ReactNativeOCRView from "./ReactNativeOCRView";
import {
  ChangeEventPayload,
  ReactNativeOCRViewProps,
} from "./ReactNativeOCR.types";

// Get the native constant value.
export const PI = ReactNativeOCRModule.PI;

export function hello(): string {
  return ReactNativeOCRModule.hello();
}

export async function setValueAsync(value: string) {
  return await ReactNativeOCRModule.setValueAsync(value);
}

const emitter = new EventEmitter(
  ReactNativeOCRModule ?? NativeModulesProxy.ReactNativeOCR
);

export function addChangeListener(
  listener: (event: ChangeEventPayload) => void
): Subscription {
  return emitter.addListener<ChangeEventPayload>("onChange", listener);
}

export { ReactNativeOCRView, ReactNativeOCRViewProps, ChangeEventPayload };
